Attribute VB_Name = "Module002_HideUN_N_Col_AllTPI"
Sub HideUN_N_Col_AllTPI()
Attribute HideUN_N_Col_AllTPI.VB_Description = "Key: Ctrl+Shift+C\nUnHides (Reverses) N columns."
Attribute HideUN_N_Col_AllTPI.VB_ProcData.VB_Invoke_Func = "C\n14"
'
' Keyboard Shortcut:Ctrl+Shift+C  ==> UnHides a set of columns of user's choice
' Suggests a complete set of columns.
' Uses Private Sub CheckSheetX(ShSearch, ExitSub)

Dim UnHideColLet As String
Dim ColNum As Long

ShSearch = "AllTPI"
Call CheckSheetX(ShSearch, ExitSub) ' Check: Sheet name exists? If not, exits with a message
If ExitSub Then Exit Sub

UnHideColLet = "NONE"  ' Default value
Sheets(ShSearch).Select
MsgStr = "Please list the AllTPI sheet Column LETTERs (A through Z) to UnHide. Example AJK will hide these three columns, or, accept the default list"
    UnHideColLet = InputBox(MsgStr, _
    "Provide LETTER(s) to UnHide Columns:", "HIJKLMNOPQUST")
    If UnHideColLet = "False" Or Len(Trim(UnHideColLet)) = 0 Then Exit Sub  'This takes care of CANCEL or Null response
        AlphaTest = UCase(UnHideColLet)
        If (Asc(AlphaTest) > 64 And Asc(AlphaTest) < 91) Then
            For ColNum = 1 To Len(UnHideColLet) Step 1
                ColLet = Mid(UnHideColLet, ColNum, 1)
                Columns(ColLet & ":" & ColLet).Select
                Selection.EntireColumn.Hidden = False
            Next
        Else: Exit Sub 'Nothing to unhide, or not a letter
        End If

Range("A1").Select ' Put the cursor back to Home
'
End Sub
'***********************************************
'***********************************************
Private Sub CheckSheetX(ShSearch, ExitSub)
'
ExitSub = False
YesNoAnswer = 0
For Each Sheet In ActiveWorkbook.Worksheets
    If Sheet.Name = ShSearch Then
        YesNoAnswer = 1
        Exit For
    Else
    End If
Next

If YesNoAnswer = 0 Then
    MsgStr = "There is no " + ShSearch + " sheet to Search, Please run: GenAllTPI"
    MsgBox MsgStr, vbOKOnly, "Missing Sheet"
    ExitSub = True
Else
End If ' Message regarding missing AllTPI ends
'
End Sub
