Attribute VB_Name = "Module003_Srch_List_W_WCs"
Sub Srch_List_W_WCs()
Attribute Srch_List_W_WCs.VB_Description = "Key: Ctrl+Shift+L\nLIST is  auto searched with Wild Cards"
Attribute Srch_List_W_WCs.VB_ProcData.VB_Invoke_Func = "L\n14"
'
' SrchListTPI Macro
'  ShortCutKey: Ctrl+Shift+L
'
' Selects TPI values from uwSrchList before searching in AllTPI
' with with exact as well as possible approximated values.  List sheet can be user modified.
' Provides a searched list of TPI values at the top and copies them into a new sheet

'The Private Sub List: for SrchListTPIwWC:
'Private Sub Chk4ShX(ShName, ShExists)
'Private Sub FindFlagAddressX(ShName, SrchCol2, FLAG, LastFlagAddress)
'Private Sub Srch_Any_ColX(TPIvalue, ColLetter, SrchShName, KeepSrches, Totalnx)
'Private Sub CopyPasteTPISrch2ListX(CopyShName, PasteShName)
'Private Sub DeleteSrchTopRwsQX()
'Private Sub CheckSheetX(ShName, ExitSub)
'Private Sub Underlines_RemoveX ()

' Should?: after searches and list are completd ask if search top rows is to be deleted.  Currently does not.
'  Good to leave the searches at the top of the AllTPI incase one wants to add to the search and then
'  Use the copy paste macro to do so.  There is no sorting of the results.  However, one can
'  sort the AllTPI prior to any searches and then use the List Sheet to order the values searched for.


Dim SrchShName As String  ' User Input: The sheet to be searched
Dim ListShName As String ' User Input: The sheet containing the List of TPI values to be found
Dim InputNum As Double  ' Used to read proposed search TPI value when found to be a number
Dim InputVar As Variant ' Used to initially read proposed search TPI value
Dim InputStr As String  ' Used to read proposed search TPI value when found to be a string
Dim k As Long        ' Proposed TPI looping counter
Dim TPIvalue As String  ' Used to transfer proposed TPI into search engine
Dim lRow As Long     ' last row of proposed TPI values
Dim KeepSrches As Long      ' Determines if previous searches will be kept or deleted
Dim ImpMetFlag As Long  ' flag to set whether to search the Imperial TPI or the Metric mm/thread column
Dim LatheName As String    ' extracted from the AllTPI sheet and pasted into the uwSrchList

ListShName = "uwSrchList"  'Checks if sheet name exists. If not, exits, message
Call Chk4ShX(ListShName, ShExists)
If ShExists = False Then Exit Sub

SrchShName = "AllTPI"  'Checks if sheet name exists. If not, exits, message
Call Chk4ShX(SrchShName, ShExists)
If ShExists = False Then Exit Sub
'SrchShName = SrchShName

Sheets(SrchShName).Select  ' Look for DELETE FLAG to see if there are previous searches, how many?
SrchCol = "B"
FLAG = "DELETE FLAG"

Call FindFlagAddressX(SrchShName, SrchCol, FLAG, LastFlagAddress)
Sheets(SrchShName).Select ' just in case it was changed in the Call
If LastFlagAddress = "None" Then LastFlagAddress = "A0"
InputStrAft1Let = Right(LastFlagAddress, Len(LastFlagAddress) - 1)
StartRow = InputStrAft1Let + 3

Sheets(SrchShName).Select  'Jump to Sheet so that the user can see any previous searches
LatheName = Range("X1")
ActiveSheet.Range("A1").Select
KeepSrches = True ' keep previous searches
KeepSrches = False ' delete previous searches
If StartRow > 3 Then
    MsgStr = "There were previous searches.  Do you wish to keep them?"
        YesNoAnswer = MsgBox(MsgStr, vbQuestion + vbYesNo)
        If YesNoAnswer = vbYes Then KeepSrches = True  ' currently deleted at TPI search
Else
End If

Call Underlines_RemoveX  ' remove the underlines for better viewing of search results

Sheets(ListShName).Select  ' ListShName = "uwSrchList"
Cells(1, 1).Select  ' for viewing, 'debug perhaps
lRow = Cells(Rows.Count, "A").End(xlUp).Row 'How many rows in the threads to be searched column
Range(Cells(1, 2), Cells(lRow, 6)) = ""  'clear the previous search results to observe this process
Range(Cells(1, 2), Cells(1, 2)) = "Total="
Range(Cells(2, 2), Cells(2, 2)) = "SrchCnt:"
Range(Cells(2, 3), Cells(2, 3)) = " Completed:"
Range(Cells(1, 4), Cells(1, 4)) = "Lathe:"
Range(Cells(1, 5), Cells(1, 5)) = LatheName

TotalEnd9999FlagCNT = 0
End9999FlagCNT = Application.WorksheetFunction.CountIf(Range(Cells(2, 1), Cells(lRow, 1)), "9999")
TotalEnd9999FlagCNT = End9999FlagCNT

If TotalEnd9999FlagCNT < 1 Then
    MsgStr = "No 9999 flag was found in the List of threads. 9999Count =  " + CStr(TotalEnd9999FlagCNT) + "  Please see uwSrchList to correct this poorly formated list.  Exit this Program?"
    YesNoAnswer = MsgBox(MsgStr, vbQuestion + vbYesNo + vbDefaultButton2, "Exit this Program?")
    If YesNoAnswer = vbYes Then Exit Sub
    Else
    End If

Sheets(ListShName).Select   '  ListShName = "uwSrchList"
ImpMetFlag = 1 'initial default value, Imperial = 1
    
If Not KeepSrches Then Call DeleteSrchTopRwsQX    ' calls Private Sub
Sheets(ListShName).Select   'ListShName = "uwSrchList"
k = 2
'ListShName = "uwSrchList"  ' without this here, the first proposed TPI value is bad!?
Sheets(ListShName).Select
Do While InputVar <> 9999   ' 9999 is placed at the end of the proposed list of searches
    Range(Cells(k, 1), Cells(k, 1)).Select
    InputVar = Range(Cells(k, 1), Cells(k, 1))
    If InputVar = "IMPERIAL" Then ImpMetFlag = 1
    If InputVar = "METRIC" Then ImpMetFlag = 2
    If ((InputVar = "METRIC") Or (InputVar = "IMPERIAL")) Then k = k + 1
    InputVar = Range(Cells(k, 1), Cells(k, 1))
    If InStr(1, InputVar, "+", 1) Or InStr(1, InputVar, "-", 1) Then InputVar = CStr(Right(InputVar, Len(InputVar) - 1))
                
    If IsNumeric(InputVar) Then ' check to see if list value is numeric or string
        InputNum = InputVar
        If InputNum = 9999 Then Exit Do
        TPIvalue = Format((InputNum), "###0.00000") ' format to make numeric into search-able string format
        If k > lRow Then Exit Do  ' safety exit
        If k > 200 Then Exit Do 'safety exit
        Application.ScreenUpdating = False  'If False then the screen does not refresh during execution.  Speed is Much better

        'SrchShName = "AllTPI"  ' sheet to be searched for TPI values
        Sheets(SrchShName).Select
        KeepSrches = True
        Totalnx = 0  'next call the search for this numerical case

        If (ImpMetFlag = 1) Then Call Srch_Any_ColX(TPIvalue, "C", SrchShName, KeepSrches, Totalnx)
        If (ImpMetFlag = 2) Then Call Srch_Any_ColX(TPIvalue, "V", SrchShName, KeepSrches, Totalnx)

        Application.ScreenUpdating = True  'Show the jump to the Sheet of the Table
        KeepSrches = True
        'ListShName = "uwSrchList"  'returns to proposed TPI list
        Sheets(ListShName).Select
        Range(Cells(k - 0, 2), Cells(k - 0, 2)) = Totalnx
        Range(Cells(k - 0, 3), Cells(k - 0, 3)) = TPIvalue  ' debug places last searched line value above List
        Range(Cells(k - 0, 4), Cells(k - 0, 4)) = Totalnx  ' debug places last searched line value above List
    Else ' Three possible searches, Exact, plus (Up), and minus (Down, Dn)
        If InStr(1, InputVar, ".", 1) = 1 Then InputVar = "0" & InputVar   'Add if missing front 0,  0.xxx rather than .xxx
        InputStr = InputVar
        If InputStr = "9999" Then Exit Do  ' end of the list to be searched
        AsteriskLoc = InStr(1, InputStr, "*", 1)  ' search for approximate values slightly less than xx.xx*
        QMLoc = InStr(1, InputStr, "?", 1)  ' search for approximate values slightly less than xx.xx?
        WCLoc = AsteriskLoc ' WCLoc= Wild Card Loc
        If QMLoc > 0 And AsteriskLoc > 0 And QMLoc <= AsteriskLoc Then WCLoc = QMLoc ' WCLoc=smaller of 1st * or ? location from left side of string
        If QMLoc > 0 And AsteriskLoc = 0 Then WCLoc = QMLoc ' WCLoc=smaller of 1st * or ? location from left side of string
        If WCLoc > 0 Then ' Wild Card exists so there is a wild card condition. We do plus and minus searches
            'With a Wild Card "*" or "?" then search for approximate values both lower (Dn) and higher (Up)
            'Wild Card = True
            DecPtLoc = InStr(1, InputStr, ".", 1) 'find decimal pt location
            Dec2AstLoc = WCLoc - DecPtLoc 'find number of char between "." and "*" locations, positive if WCLoc is right of decimal pt
            If DecPtLoc = 0 Then Dec2AstLoc = 0 ' no decimal point, integer "like"
            InputStrB4WC = Left(InputStr, WCLoc - 1) ' input string prior to wild card
            InputStrPlus = InputStrB4WC & "*"
            
            InputStrWC = InputStrB4WC & "*"
            InputStr = InputStrWC
             
            Dim InputStrB4WCN As Double ' makes this string into a number to allow substraction below
            InputStrB4WCN = InputStrB4WC
            If Dec2AstLoc = 5 Then InputStrMinus = InputStrB4WCN - 0.0001  ' example: WC is in the 4th decimal place.
            If Dec2AstLoc = 4 Then InputStrMinus = InputStrB4WCN - 0.001
            If Dec2AstLoc = 3 Then InputStrMinus = InputStrB4WCN - 0.01
            If Dec2AstLoc = 2 Then InputStrMinus = InputStrB4WCN - 0.1
            If Dec2AstLoc = 1 Then InputStrMinus = InputStrB4WCN - 1
                                
            '******************************
            If Dec2AstLoc > 0 Then  ' decimal to the right of the Wild card
            TPIvalueTempMinus = Format((InputStrMinus), "###0.00000") ' format to search-able string format for text search
            TPIvalueTempPlus = Format((InputStrPlus), "###0.00000") ' format to search-able string format for text search
            InputStrAF4AstMinus = Left(TPIvalueTempMinus, WCLoc - 1) & "*"
            InputStrAF4AstPlus = Left(TPIvalueTempPlus, WCLoc - 1) & "*"
            Else
                If Dec2AstLoc = 0 Then
                    InputStrB4WCN = InputStrB4WC & ".0"
                    InputStrMinus = InputStrB4WCN - 0.1
                    InputStrPlus = InputStrB4WCN
                    TPIvalueTempMinus = Format((InputStrMinus), "###0.00000") ' format to search-able string format for text search
                    TPIvalueTempPlus = Format((InputStrPlus), "###0.00000") ' format
                    InputStrAF4AstMinus = Left(TPIvalueTempMinus, WCLoc - 0) & "*"
                    InputStrAF4AstPlus = Left(TPIvalueTempPlus, WCLoc - 1) & ".*"
                End If
            End If
            If Dec2AstLoc < 0 Then
                If Dec2AstLoc = -1 Then '
                    InputStrB4WCN = InputStrB4WC & "0."
                    InputStrMinus = InputStrB4WCN - 1
                    InputStrPlus = InputStrB4WCN
                    TPIvalueTempMinus = Format((InputStrMinus), "###0.00000") ' format to search-able string format for text search
                    TPIvalueTempPlus = Format((InputStrPlus), "###0.00000") ' format to search-able string format for text search
                    InputStrAF4AstMinus = Left(TPIvalueTempMinus, WCLoc - 0) & ".*"
                    InputStrAF4AstPlus = Left(TPIvalueTempPlus, WCLoc - 1) & "0.?????"
                End If
                If Dec2AstLoc = -2 Then
                    InputStrB4WCN = InputStrB4WC & "00."
                    InputStrMinus = InputStrB4WCN - 10
                    InputStrPlus = InputStrB4WCN
                    TPIvalueTempMinus = Format((InputStrMinus), "###0.00000") ' format to search-able string format for text search
                    TPIvalueTempPlus = Format((InputStrPlus), "###0.00000") ' format to search-able string format for text search
                    InputStrAF4AstMinus = Left(TPIvalueTempMinus, WCLoc - 0) & "?.*"
                    InputStrAF4AstPlus = Left(TPIvalueTempPlus, WCLoc + 2) & "*"
                End If
                    If Dec2AstLoc = -3 Then
                    InputStrB4WCN = InputStrB4WC & "000."
                    InputStrMinus = InputStrB4WCN - 100
                    InputStrPlus = InputStrB4WCN
                    TPIvalueTempMinus = Format((InputStrMinus), "###0.00000") ' format to search-able string format for text search
                    TPIvalueTempPlus = Format((InputStrPlus), "###0.00000") ' format to search-able string format for text search
                    InputStrAF4AstMinus = Left(TPIvalueTempMinus, WCLoc - 0) & "??.*"
                    InputStrAF4AstPlus = Left(TPIvalueTempPlus, WCLoc + 3) & "*"
                End If
            End If

            Application.ScreenUpdating = False  'If False then the screen does not refresh during execution.  Speed is Much better
            SrchShName = "AllTPI"  ' sheet to be searched for TPI values
            Sheets(SrchShName).Select
            KeepSrches = True
            Totalnx = 0

            If (ImpMetFlag = 1) Then Call Srch_Any_ColX(InputStrAF4AstMinus, "C", SrchShName, KeepSrches, Totalnx)
            If (ImpMetFlag = 2) Then Call Srch_Any_ColX(InputStrAF4AstMinus, "V", SrchShName, KeepSrches, Totalnx)

            Application.ScreenUpdating = True  'Show the jump to the Sheet of the Table. = False,Speed is Much better
            KeepSrches = True
            ' ListShName = "uwSrchList"  'returns to proposed TPI list
            Sheets(ListShName).Select
            Range(Cells(k - 0, 2), Cells(k - 0, 2)) = Totalnx
            Range(Cells(k - 0, 5), Cells(k - 0, 5)) = InputStrAF4AstMinus  ' debug places last searched line value above List
            Range(Cells(k - 0, 6), Cells(k - 0, 6)) = Totalnx
                  
            ' search for approximate values slightly greater than xx.xx*
            ' need to remove the * from InputStr then set up and call search
            ' WCLoc = InStr(1, InputStr, "*", 1) 'already have this value from above
            InputStrPlus = InputVar  ' already a string as it has an "*"
            TPIvalue = InputVar ' format is text with "*"

            Application.ScreenUpdating = False  'If False then the screen does not refresh during execution.  Speed is Much better
            SrchShName = "AllTPI"  ' sheet to be searched for TPI values
            Sheets(SrchShName).Select
            KeepSrches = True
            Totalnx2 = Totalnx
            Totalnx = 0
            If (ImpMetFlag = 1) Then Call Srch_Any_ColX(InputStrAF4AstPlus, "C", SrchShName, KeepSrches, Totalnx)
            If (ImpMetFlag = 2) Then Call Srch_Any_ColX(InputStrAF4AstPlus, "V", SrchShName, KeepSrches, Totalnx)

            Application.ScreenUpdating = True  'Show the jump to the Sheet of the Table.  =False Speed is Much better
            KeepSrches = True
            Totalnx2 = Totalnx2 + Totalnx  ' keep total from searches just smaller than TPI value
            ' ListShName = "uwSrchList"  'returns to proposed TPI list
            Sheets(ListShName).Select
            Range(Cells(k - 0, 2), Cells(k - 0, 2)) = Totalnx2
            Range(Cells(k - 0, 3), Cells(k - 0, 3)) = InputStrAF4AstPlus  ' debug places last searched line value above List
            Range(Cells(k - 0, 4), Cells(k - 0, 4)) = Totalnx
        End If  ' ended + and - searches where there was an "*"
    End If
    k = k + 1  ' move to the next value in the list of SrchList
Loop

Call CopyPasteTPISrch2ListX(SrchShName, SrchdTPI) 'PasteShName = "SrchdTPI" ' Copy & paste search results from AllTPI to PasteShName sheet.
Sheets(ListShName).Select ' back to the List page to watch the progress.
Cells(1, 1).Select

End Sub
'************************************************************

'************************************************************
Private Sub Chk4ShX(ShName, ShExists)

' Program to Check for a Sheet's Existance
' Returns a ShExists=True if the sheet exists
' First check to see if a target sheet name was provided and respond:
' If none is provided then Default to AllTPI

' Variables arrive as:
' Dim Srch4Sh As String
' Dim ShExists As Boolean

If ShName = "" Then
    MsgStr = "No Sheet Name was provided!  OK to Default to AllTPI?"
    'MsgBox MsgStr, vbOKOnly
    'MsgBox MsgStr, vbOK, "No Sheet Name Provided"
    MsgBox MsgStr, vbOKCancel + vbDefaultButton2, "No Sheet Name Provided"
    ShName = "AllTPI"
Else
End If

ShExists = False  ' Now check to see if the Sheet Name exists.
For Each Sheet In ActiveWorkbook.Worksheets
    If Sheet.Name = ShName Then
        ShExists = True
        Exit For
    Else
    End If
    Next

If ShExists = 0 Then
    MsgStr = "There is no " + ShName + " sheet. Please correct or select another name."
    MsgBox MsgStr, vbOKOnly, "Missing Sheet"
    Exit Sub
Else
End If ' Message ends

Worksheets(ShName).Select
Range("A1").Select
End Sub

'************************************************************

'************************************************************
Private Sub FindFlagAddressX(SrchShName, SrchCol2, FLAG, LastFlagAddress)

'This works Great.  If finds the address of the last occurance of
'the "DELETE FLAG"
'Nice and short code to yield the cell address

Dim ColRng As Range, where As Range, whatt As String
Sheets(SrchShName).Select
whatt = FLAG
Set ColRng = Range(SrchCol2 & ":" & SrchCol2)
Set where = ColRng.Find(What:=whatt, after:=ColRng(ColRng.Cells.Count), searchdirection:=xlPrevious)
If Not where Is Nothing Then
    LastFlagAddress = where.Address(0, 0)
Else
    LastFlagAddress = "None"
Exit Sub
End If

End Sub

'************************************************************

'************************************************************
Private Sub Srch_Any_ColX(TPIvalue, ColLetter, SrchShName, KeepSrches, Totalnx)

' Search for a value at provided Column letter, Imperial =C, METRIC = V
' Requested for this search changes TPIvalue to accomdate all wild cards
' Perhaps that should be moved to inside this sub?

' causes a search of column V, mmPT, of sheet AllTPI for a user defined mmPT value
' The search supports wild cards or an exact x.xxxxx style number
' Then high-lites what is found and
'  places a copy of that row at the top of the "AllITP" sheet.

    Dim Xf As Long ' to be the found column number
    Dim Yf As Long  ' to be the found row number
    Dim Valf As Double ' what is the value found in the cell found
    Dim ValfStr As String ' cell value to display
    'Dim SrchShName As String  ' User Input: The sheet to be searched
    Dim lRow As Long ' last row number of the data
    Dim lCol As Long ' last column number of the data
    Dim lColi As Long 'the number of columns in the virgin AllTPI
    Dim TPIRangeCol3 As Range  ' range of actual data in column 3
    Dim AllDataRange As Range  ' range of actual data in sheet
    Dim TPIsrch As String  ' the TIP to be searched for, input from the user msgbox
    Dim MsgStr As String  ' long message box string to the user
    Dim Totaln As Long  ' A counter of the search results
    Dim rFirst As Range
    Dim r As Range
    Dim A As Range
    Dim MyString As String
    Dim Copyn As Long
    Dim CopyRow As Long
    Dim DeleteFlagCnt As Long
    Dim DeleteFlagNum As Long
    Dim TotalDeleteRowCnt As Long
    Dim YesNoAnswer As Integer
    Dim TotalDELETEFLAGRows As Long
    Dim SrchColLet As String  ' the Column Letter to be searched
    Dim SrchColNum As Long ' the Column # to be searched, converted from Letter
    
    SrchColLet = ColLetter
    SrchShName = SrchShName
ShName = SrchShName
Call Chk4ShX(ShName, ShExists)
If ShExists = False Then Exit Sub
' Revisions N302 start
'    SrchShName = "AllTPI"
' Checking to see if the sheet name exists. If not then exits with a 'message
'    YesNoAnswer = 0
'    For Each Sheet In ActiveWorkbook.Worksheets
'        If Sheet.Name = SrchShName Then
'            YesNoAnswer = 1
'            Exit For
'        Else
'        End If
'    Next
'     If YesNoAnswer = 0 Then
'            MsgStr = "There is no " + SrchShName + " sheet to Search, 'Please run: GenAllTPI"
'            MsgBox MsgStr, vbOKOnly, "Missing Sheet"
'        Exit Sub
'        Else
'        End If
' Revisions N302 end
      
    Sheets(SrchShName).Select
    
    lRow = Cells(Rows.Count, "C").End(xlUp).Row
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
    lColi = lCol   'The initial Column Count

'Count the number of DELETE FLAGs found. If any keep previous searches if KeepSrches=True
    DeleteFlagCnt = Application.WorksheetFunction.CountIf(Range(Cells(1, 2), Cells(lRow, 2)), "DELETE FLAG")
    TotalDeleteRowCnt = 0
    If DeleteFlagCnt > 0 Then
'        MsgStr = "There has been " + CStr(DeleteFlagCnt) + " previous search(s).  Do you wish to keep them?"
'        YesNoAnswer = MsgBox(MsgStr, vbQuestion + vbYesNo + vbDefaultButton2, "Keep Previous Searches")
        If KeepSrches Then YesNoAnswer = vbYes
        If Not KeepSrches Then YesNoAnswer = vbNo
        If YesNoAnswer = vbNo Then
            '********* Clean up previous TPI search via deletions
            Call DeleteSrchTopRwsQX ' Private Subroutine call to remove previous searches.
        Else
        End If
        
    End If
      
'******************  Search Column Requested
    
'    MsgStr = "Please Type the Column letter you wish to search:  Example: D."
'        SrchColLet = InputBox(MsgStr, _
            "Search Column Letter", c)

    If SrchColLet = "False" Or Len(Trim(SrchColLet)) = 0 Then Exit Sub  'This takes care of CANCEL or Null response
'    Range("I1") = SrchColLet   'debug or allows one to see the sort requested moved this to the subroutine ending lines to prevent rewriting
 '**********************************************
 '******************  Search Column Number
  If SrchColLet <> "ORIGINAL_ORDER" Then
        If Asc(SrchColLet) > 96 Or 123 < Asc(SrchColLet) Then 'if lower case letters a through z convert to upper case
        SrchColNum = Asc(SrchColLet) - (97 - 65)  ' sort column number, converts from lower case to upper case
        SrchColLet = Chr(SrchColNum)  'New sort column letter in upper case
        Else
            If Asc(SrchColLet) < 65 Or 90 < Asc(SrchColLet) Then  ' avoid characters except for A through Z
            SrchColLet = "A"  ' if the letter is out of range then do a sort on the orignial row numbers.
            SrchColNum = Asc(SrchColLet) - 64
            Else
            End If
        End If
    SrchColNum = Asc(SrchColLet) - 64
    Else
    SrchColLet = "A"  'If "ORIGINAL_ORDER" is returned then do sort on row numbers.
    SrchColNum = Asc(SrchColLet) - 64
    End If
    
'    Range("J1") = Asc(SrchColLet) - 64 'Debug info, --- moved this to the subroutine ending lines to prevent rewriting
'    Range("L1") = SColSign 'Debug info
'    SrchColNum = Abs(SrchColNum)
      

'*************************
    If YesNoAnswer = vbYes Then
'Count the number of rows from 1 to the last "DELETE FLAG" if anser is yes
        DeleteFlagNum = 0
        Yf = 1
        lRow = Cells(Rows.Count, 3).End(xlUp).Row   ' this is all row including search rows
'        lRow = Cells(Rows.Count, "C").End(xlUp).Row
        Do While DeleteFlagNum < DeleteFlagCnt  ' find number of rows holding previous searches
            Stopn = False
            Do While Yf < lRow
                If Cells(Yf, 2) = "DELETE FLAG" Then
                    Stopn = True
                    Yf = Yf + 1
                End If
            Yf = Yf + 1
                If Stopn Then Exit Do
                Stopn = False
            Loop
            DeleteFlagNum = DeleteFlagNum + 1
        Loop
       
'        Cells(Yf - 2, 23) = Yf - 2 ' this is the number of rows TO The last DELETE FLAG.
        Cells(Yf - 2, 27) = Yf - 2 ' this is the number of rows TO The last DELETE FLAG.
        Cells(Yf - 2, lColi + 5) = Yf - 2 ' this is the number of rows TO The last DELETE FLAG.
        
        TotalDeleteRowCnt = Yf - 2 ' new name
    Else
        TotalDeleteRowCnt = 0  ' however it is zero anyway since the delete top rows was run.
        Yf = 0
        lRow = Cells(Rows.Count, 3).End(xlUp).Row
    End If
    
  
'******************* Clean up previous TPI search via deletions????
 '   Call DeleteSrchTopRwsQX ' makes this Subroutine call to removed previous searches.
'*************

'Start search for TPI
    Range("A1").Select
'Find the last non-blank cell in column 3
    lRow = Cells(Rows.Count, 3).End(xlUp).Row
    
'Find the last non-blank cell in row lRow.  If the cell has been used before it will not be blank as it
' will have hidden control characters.  To remove control characters used c.Clear or just rebuilt the sheet
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
       
' Clear all available cells after the titles to the historic colors and fonts
  '  Range(Cells(1, TotalDeleteRowCnt + 3), Cells(lRow, lCol)).Interior.Color = RGB(255, 255, 255) ' 255, 255, 255 => clear!
  '  Range(Cells(1, TotalDeleteRowCnt + 3), Cells(lRow, lCol)).Font.Color = RGB(0, 0, 0)  ' 0, 0, 0 => black!
  '  Range(Cells(1, TotalDeleteRowCnt + 3), Cells(lRow, lCol)).Font.FontStyle = "Normal" 'Clears font stytle from "Bold Italic"
    
'    Set AllDataRange = Application.Range(Cell1:="A3", Cell2:=Cells(lRow, lCol))
' Clear font color, font style, cell color of previous searches for the range after the last DELETE FLAG and table titles
If YesNoAnswer = vbYes Then
'    Set TPIRangeCol22 = Application.Range(Cell1:=Cells(TotalDeleteRowCnt + 3, SrchColNum), Cell2:=Cells(lRow, SrchColNum))
    Set TPIRangeCol22 = Application.Range(Cell1:=Cells(TotalDeleteRowCnt + 3, 1), Cell2:=Cells(lRow, lCol))
    TPIRangeCol22.Font.Color = RGB(0, 0, 0) ' make colum 3 font data black, removes previous search color
    TPIRangeCol22.Interior.Color = RGB(255, 255, 255) ' make colum 3 clear fill, removes previous search color
    TPIRangeCol22.Font.FontStyle = "Normal" 'Clears font stytle from "Bold Italic"
Else
'    Set TPIRangeCol22 = Application.Range(Cell1:=Cells(3, 3), Cell2:=Cells(lRow, 3))
    Set TPIRangeCol22 = Application.Range(Cell1:=Cells(3, 1), Cell2:=Cells(lRow, lCol))
    TPIRangeCol22.Font.Color = RGB(0, 0, 0) ' make colum 3 font data black, removes previous search color
    TPIRangeCol22.Interior.Color = RGB(255, 255, 255) ' make colum 3 clear fill, removes previous search color
    TPIRangeCol22.Font.FontStyle = "Normal" 'Clears font stytle from "Bold Italic"
End If

'Message providing the search criteria
'    MsgStr = "Please Replace w/ the desired VALUE. It must have a decimal point and be 5 decimal number! For an EXACT " + _
        "Search: Type Exact number: Examples: 48.00000 or 0.00506, but NOT 04.00000 nor .056. However wild cards " + _
        " are allowed: ? any single character, *=any number of following characters may be use instead.   Note: " + _
        "Table numbers are treated as TEXT in the format of *?.?????  So a good search might be 13.0????" + _
        " or 13.0* to yield both 13.00000 and 13.02345" + "  Or, *.00000 to yield all the integers! " + _
        " If you want them ordered differently run the sorting macro first."
        
'        TPIsrch = InputBox(MsgStr, _
            "Search For YOUR Desired VALUE", "Your Value Goes Here")
TPIsrch = TPIvalue
        
'    Range("Y1") = TPIsrch       ' debug
'    Range("Y2") = Len(TPIsrch)  ' debug
    
    nFail = False
'If Len(TextBox1) = 0 Then
    If Len(TPIsrch) = Len("Your Number Goes Here") Then
        MsgBox "Search Variable has not been Provided Properly."
        nFail = True
        'Range("Y1") = "nStop = True"
    ElseIf Len(TPIsrch) = Len("") Then
        MsgBox "Search Variable has not been Provided Properly."
        nFail = True
        'Range("Y1") = "nStop = True"
    ElseIf Len(TPIsrch) = Len(" ") Then
        MsgBox "Search Variable has not been Provided Properly."
        nFail = True
        'Range("Y1") = "nStop = True"
    ElseIf InStr(1, TPIsrch, ".", 1) = 0 Then
        MsgBox "Search Variable has not been Provided Properly."
        nFail = True
    Else
    End If
    
    DecPtLoc = InStr(1, TPIsrch, ".", 1)
        
    Set A = Range(Cells(TotalDeleteRowCnt + 3, SrchColNum), Cells(lRow, SrchColNum)) 'only search from below the last DELETE FLAG row
    MyString = "  "
    Totaln = 0
    Do
        If nFail Then Exit Do
   
        If rFirst Is Nothing Then
         'Set rFirst = A.Find(What:=TPIsrch, After:=A(1))
            Set rFirst = A.Find(What:=TPIsrch, after:=A(1), lookat:=xlWhole)
            If rFirst Is Nothing Then Exit Do  'Finally this works when the data does not match anything
                Set r = rFirst
            Else
'               'Set r = A.Find(What:=TPIsrch, After:=r)
                Set r = A.Find(What:=TPIsrch, after:=r, lookat:=xlWhole)
                If r.Address = rFirst.Address Then Exit Do
            End If
        Totaln = Totaln + 1
        MyString = MyString & "  " & r.Offset(0, -2)
             
'***********************
        Xf = r.Column  'r is a range, this command finds the first Row of that range, the found value
        Yf = r.Row      ''r is a range, this command finds the first Column of that range
        
        ' this is a scratch pad location, stores the found value's row number, which is needed for copy-paste of row
        Cells(Totaln, lColi + 7) = r.Row
        
        Cells(Yf, Xf).Select
        ActiveCell.Interior.ColorIndex = 6
        ActiveCell.Font.FontStyle = "Bold Italic"
        ActiveCell.Font.ColorIndex = 3

        Valf = ActiveCell.Value
        ValfStr = "  " + CStr(Valf) + "  = Requested Value found"

    Loop
    
    If nFail Then
        'MsgBox "You entered no number!"
    Else
        TotalinfoString = "Total number of Results = " + CStr(Totaln)
        'MsgBox CStr(Totaln)
        'MsgBox TotalinfoString
        If Totaln <> 0 Then
            MyString = "Results Found at Row #'s:   " + MyString
            'MsgBox MyString
            '******************************
        Else
        End If
    End If
    
' Insert some rows
    Range("A1").Select  ' move back to the top of the page. why.  debug?
    If Not nFail Then
        If Not nStop Then
            If Not rFirst Is Nothing Then
                Range("A1:A" & Totaln + 2 + 1).EntireRow.Insert
                Range("B" & Totaln + 2 + 1) = "DELETE FLAG"
                Range("D" & Totaln + 2 + 1) = Totaln
                Range("F" & Totaln + 2 + 1) = " = Total No. of Search Results"

                Range("A1").Select  ' move back to the top of the page. why.  debug?
                Range(Cells(Totaln + 2 + 2, 1), Cells(Totaln + 3 + 2, lCol)).Select
                Selection.Copy  ' select and copy the titles

                Range("A1").Select  ' Paste the titles at top of page.
                Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
                    SkipBlanks:=False, Transpose:=False
                Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
                    :=False, Transpose:=False

                Copyn = 1
                Do While Copyn <= Totaln
                    CopyRow = Cells(Totaln + 2 + 1 + Copyn, lColi + 7).Value
'Range(Cells(Totaln + 5+ Range("X"& Totaln+5, 1)).Select
                    Range(Cells(CopyRow + Totaln + 2 + 1, 1), Cells(CopyRow + Totaln + 2 + 1, lCol)).Select
                    Selection.Copy   ' copy and paste the found data in the new space at the top
                    Cells(Copyn + 2, 1).Select
                    Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
                        SkipBlanks:=False, Transpose:=False
                    Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
                        :=False, Transpose:=False

                    Copyn = Copyn + 1
                    Totalnx = Totaln
                Loop
                Range("A1").Select
                Else
            End If
        End If
    End If
    
'*****************************************
    ' Delete a few columns at right to clean up and to make the new last column a Null value.
    I = 1
    imax = 8
    Columns(lColi + 1 + imax).EntireColumn.Insert
    While I <= imax + 1
        Columns(lColi + 1).EntireColumn.Delete
        I = I + 1
    Wend

Range("A1").Select  ' Place cursor at the top left and stop

End Sub

'************************************************************

'************************************************************

Private Sub CopyPasteTPISrch2ListX(CopyShName, PasteShName)
'Former Sub StandTPIList()
'Key?

'If PasteShName sheet exists then deletes it and creats a new one
'Checks the number of searched results in CopyShName/AllTPI and Copies
'and Pastes them to the new sheet with formating and column widths.
'Copy and Transfers the hidden column attributes


'Dim PasteShName As String
'Dim CopyShName As String
Dim FLAG As String
Dim NewlRow As Long

If CopyShName = "" Then CopyShName = "AllTPI"
If PasteShName = "" Then PasteShName = "SrchdTPI"
'PasteShName = "SrchdTPI"
'PasteShName = "SrchdTPI"
PasteShName = PasteShName
'CopyShName = "AllTPI"
  
Application.DisplayAlerts = False
For Each Sheet In ActiveWorkbook.Worksheets 'If SrchdTPI sheet exists delete it
    If Sheet.Name = PasteShName Then Sheet.Delete
Next Sheet
Application.DisplayAlerts = True

Sheets.Add(Before:=Sheets(1)).Name = PasteShName 'create new sheet at first tab position

Sheets(CopyShName).Select
SrchCol = "B"
FLAG = "DELETE FLAG"
Call FindFlagAddressX(CopyShName, SrchCol, FLAG, LastFlagAddress)

Sheets(CopyShName).Select ' just in case it was changed in the Call
If LastFlagAddress = "None" Then LastFlagAddress = "A0"
InputStrAft1Let = Right(LastFlagAddress, Len(LastFlagAddress) - 1)
LastFlagRow = InputStrAft1Let

lRow = Cells(Rows.Count, "C").End(xlUp).Row
lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
Range(Cells(1, 1), Cells(LastFlagRow + 2, lCol)).Select ' also copy titles at bottom
Selection.Copy   ' copy and paste the found data into the new sheet
Worksheets(PasteShName).Select
Cells(1, 1).Select
'Selection.PasteSpecial Paste:=xlPasteValues, Operation:=xlNone, SkipBlanks _
    :=False, Transpose:=False
'Selection.PasteSpecial Paste:=xlPasteFormats, Operation:=xlNone, _
    SkipBlanks:=False, Transpose:=False
Selection.PasteSpecial Paste:=xlPasteAll, Operation:=xlNone, _
    SkipBlanks:=False, Transpose:=False
Selection.PasteSpecial Paste:=xlPasteColumnWidths, Operation:=xlNone, _
    SkipBlanks:=False, Transpose:=False

Sheets(CopyShName).Select
Range("A1").Select  ' after paste go back and turn off the copy cell highlight
Application.CutCopyMode = False ' removes copied material from Excel Clipboard
Worksheets(PasteShName).Select

CCol = 1
Do While CCol <= lCol
If Sheets(CopyShName).Columns(CCol).Hidden = True Then Sheets(PasteShName).Columns(CCol).Hidden = True
CCol = CCol + 1
Loop

Application.DisplayAlerts = False
Sheets(PasteShName).Select
NewlRow = Cells(Rows.Count, "C").End(xlUp).Row
IRow = 1
Do While IRow <= NewlRow ' underline bottom of each TPI group and remove intermediate titles
    RRow = NewlRow - IRow + 1
    If Cells(RRow, 2).Value = FLAG Then
        With Range(Cells(RRow - 1, 1), Cells(RRow - 1, lCol)).Borders(xlEdgeBottom)
            .LineStyle = xlDouble
            .Weight = xlMedium
            .ColorIndex = 0
        End With
        With Range(Cells(RRow, 1), Cells(RRow, lCol)).Borders(xlEdgeBottom)
            .LineStyle = xlDouble
            .Weight = xlMedium
            .ColorIndex = 0
        End With
    End If
    IRow = IRow + 1
Loop

NewlRow = Cells(Rows.Count, "C").End(xlUp).Row

IRow = 1
Do While IRow <= NewlRow ' underline bottom of each TPI group and remove intermediate titles
    RRow = NewlRow - IRow + 1
    If Cells(RRow, 2).Value = FLAG Then Rows(RRow + 2).Delete ' Delete titles two rows below FLAG
    If Cells(RRow, 2).Value = FLAG Then Rows(RRow + 1).Delete ' Delete titles one row below FLAG
    IRow = IRow + 1
Loop
Application.DisplayAlerts = True
Range("A1").Select ' clears the pages from the copy

End Sub

'************************************************************

'************************************************************
Private Sub DeleteSrchTopRwsQX()
    'N424_1206
    ' Much improved "Q"=Quickly
    ' This program works well and is shorter and quicker than.
    ' Delete the top rows of a previous search
    ' Calls no other Subs

    Dim ShSearch As String
    Dim FLAG As String
    Dim DELrng As Range
    
    ShSearch = "AllTPI"
'*****************
'    ShExists = 0
'    For Each Sheet In ActiveWorkbook.Worksheets
'        If Sheet.Name = ShSearch Then
'            ShExists = 1
'            Exit For
'        Else
'        End If
'        Next
'    If ShExists = 0 Then
'        MsgStr = "There is no " + ShSearch + " sheet to work on"
'        MsgBox MsgStr, vbOKOnly, "Missing Sheet"
'        ExitSub = True
'    Else
'    End If
'***************************
    Sheets(ShSearch).Select
    FLAG = "DELETE FLAG"
    SrchCol = "B"
    Set DELrng = Range(SrchCol & ":" & SrchCol)
    'Set DELrng = Range("B" & ":" & "B")
    Set where = DELrng.Find(What:=FLAG, after:=DELrng(DELrng.Cells.Count), searchdirection:=xlPrevious)
    LastFlagRowExist = True
    If Not where Is Nothing Then
        LastFlagAddress = where.Address(0, 0)
        LastFlagRow = Split(where.Address, "$")(2)
        LastFlagRowExist = True
    Else
        LastFlagAddress = "None"
        LastFlagRowExist = False
    End If

    If LastFlagRowExist Then
    Range(Rows(1), Rows(LastFlagRow)).Select
    Selection.EntireRow.Delete  'Deletes entire range
    Else
    End If
    
    lRow = Cells(Rows.Count, 3).End(xlUp).Row   ' clean up search colors etc.
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
    Set TPIRangeCol22 = Application.Range(Cell1:=Cells(3, 1), Cell2:=Cells(lRow, lCol))
    TPIRangeCol22.Font.Color = RGB(0, 0, 0) ' make range font data black, removes previous search color
    TPIRangeCol22.Interior.Color = RGB(255, 255, 255) ' make range clear fill, removes previous search color
    TPIRangeCol22.Font.FontStyle = "Normal" 'Clears font style from "Bold Italic"
    
    Range("A1").Select

End Sub

'*************************************
'*************************************

Private Sub CheckSheetX(ShName, ExitSub)
'
ExitSub = False
YesNoAnswer = 0
For Each Sheet In ActiveWorkbook.Worksheets
    If Sheet.Name = ShName Then
        YesNoAnswer = 1
        Exit For
    Else
    End If
    Next
If YesNoAnswer = 0 Then
    MsgStr = "There is no " + ShName + " sheet to Search, Please run: GenAllTPI"
    MsgBox MsgStr, vbOKOnly, "Missing Sheet"
    ExitSub = True
Else
End If ' Message regarding missing AllTPI ends
'
End Sub
'************************************************************
'************************************************************
Private Sub Underlines_RemoveX()

'
' RemoveUnderlines Macro
' Ctro+Shift+R Removes the underlines in the AllTPI table
'
' Keyboard Shortcut: Ctrl+Shift+R

'This works well, but
' Calls only Chk4ShX
' It removes lines even if they are in the searched areas? but
' Doesnt it also remove the lines under the captions?

' creat an equivalent to insert lines?  Not of a great deal of value
' after we removed the duplicate rows and lines no longer correspond to gear changes
' should it be made to automatically suggest the number of lines based upon the lathe
' gear box first column of possibilities?
' Should work even with previous searches?
' so a the find DELETE FLAGX sub could be used.


'
    Dim ShName As String  ' User Input: The sheet to be searched
    Dim lRow As Long ' last row number of the data
    
    
    Dim lCol As Long ' last column number of the data
    Dim lColi As Long 'the number of columns in the virgin AllTPI
    Dim MsgStr As String  ' long message box string to the user
    Dim I As Long
    Dim LatheSheetName As String
    
    ShName = "AllTPI"
' Checking to see if the sheet name exists. If not then exits with a message

Call Chk4ShX(ShName, ShExists)
If ShExists = False Then Exit Sub

Sheets(ShName).Select
    LatheSheetName = Cells(1, 8) 'Retrive the lathe sheet name from the ALLTPI table title
    
    lRow = Cells(Rows.Count, "C").End(xlUp).Row
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
    Range(Cells(1, 1), Cells(lRow, lCol)).Select
    'Range("A1:Z506").Select
    Selection.Borders(xlDiagonalDown).LineStyle = xlNone
    Selection.Borders(xlDiagonalUp).LineStyle = xlNone
    Selection.Borders(xlEdgeLeft).LineStyle = xlNone
    Selection.Borders(xlEdgeTop).LineStyle = xlNone
    Selection.Borders(xlEdgeBottom).LineStyle = xlNone
    Selection.Borders(xlEdgeRight).LineStyle = xlNone
    Selection.Borders(xlInsideVertical).LineStyle = xlNone
    Selection.Borders(xlInsideHorizontal).LineStyle = xlNone
        
    I = 1
    Do While I < lRow
        If StrComp(Range(Cells(I, 3), Cells(I, 3)), "TPI") = 0 Then
            Range(Cells(I, 1), Cells(I, lCol)).Select
            Selection.Borders(xlDiagonalDown).LineStyle = xlNone
            Selection.Borders(xlDiagonalUp).LineStyle = xlNone
            Selection.Borders(xlEdgeLeft).LineStyle = xlNone
            Selection.Borders(xlEdgeTop).LineStyle = xlNone
            With Selection.Borders(xlEdgeBottom)
                .LineStyle = xlDouble
                .ColorIndex = 0
                .TintAndShade = 0
                .Weight = xlThick
            End With
            Selection.Borders(xlEdgeRight).LineStyle = xlNone
            Selection.Borders(xlInsideVertical).LineStyle = xlNone
            Selection.Borders(xlInsideHorizontal).LineStyle = xlNone
            
            I = I + 1
        Else
            I = I + 1
        End If
    Loop
      
    Range("A1").Select

End Sub
'************************************************************
'************************************************************


