Attribute VB_Name = "Module004_DeleteSrchTopRwsQ"
Sub DeleteSrchTopRwsQ()
Attribute DeleteSrchTopRwsQ.VB_Description = "Key: Ctrl+Shift+D\nDeletes the top searched rows from AllTPI sheet"
Attribute DeleteSrchTopRwsQ.VB_ProcData.VB_Invoke_Func = "D\n14"
    
    ' KeyStrokeShort cut: Ctrl+Shift+D
    
    'N424_1206
    ' Much improved,   "Q"=Quickly
    ' This program works well and is short and quick.
    ' Delete the top rows of previous searches
    ' Calls no other Subs, self contained

    Dim ShSearch As String
    Dim FLAG As String
    Dim DELrng As Range
    
    ShSearch = "AllTPI"
'*****************
    ShExists = 0
    For Each Sheet In ActiveWorkbook.Worksheets
        If Sheet.Name = ShSearch Then
            ShExists = 1
            Exit For
        Else
        End If
        Next
    If ShExists = 0 Then
        MsgStr = "There is no " + ShSearch + " sheet to work on"
        MsgBox MsgStr, vbOKOnly, "Missing Sheet"
        ExitSub = True
    Else
    End If
'***************************
    Sheets(ShSearch).Select
    FLAG = "DELETE FLAG"
    SrchCol = "B"
    Set DELrng = Range(SrchCol & ":" & SrchCol)
    'Set DELrng = Range("B" & ":" & "B")
    Set where = DELrng.Find(What:=FLAG, after:=DELrng(DELrng.Cells.Count), searchdirection:=xlPrevious)
    LastFlagRowExist = True
    If Not where Is Nothing Then
        LastFlagAddress = where.Address(0, 0)
        LastFlagRow = Split(where.Address, "$")(2)
        LastFlagRowExist = True
    Else
        LastFlagAddress = "None"
        LastFlagRowExist = False
        
    End If

    If LastFlagRowExist Then
        Range(Rows(1), Rows(LastFlagRow)).Select
        Selection.EntireRow.Delete  'Deletes entire range
    Else
    End If
        'Remove Table TPI colors and formating left over from a search
    lRow = Cells(Rows.Count, 3).End(xlUp).Row
    lCol = Cells(lRow, Columns.Count).End(xlToLeft).Column
    If lCol < 26 Then lCol = 26 'Excel quirk, if the last column is hidden it is missed by End(xlToLeft).Column
    Set TPIRangeCol22 = Application.Range(Cell1:=Cells(3, 1), Cell2:=Cells(lRow, lCol))
    TPIRangeCol22.Font.Color = RGB(0, 0, 0) ' make range font data black, removes previous search color
    TPIRangeCol22.Interior.Color = RGB(255, 255, 255) ' make range clear fill, removes previous search color
    TPIRangeCol22.Font.FontStyle = "Normal" 'Clears font style from "Bold Italic"
    
    Range("A1").Select

End Sub

